<script>
import DipasButton from "../../../reusableComponents/DipasButton.vue";
import moment from "moment";

export default {
  name: "TopContributionsByValue",
  components: {
    DipasButton
  },
  props: {
    /**
     * data to display
     */
    dataToShow: {
      type: Array,
      default: null
    }
  },
  data () {
    return {
      openedContribution: 0
    };
  },
  computed: {
    contributionList () {
      if (this.dataToShow) {
        return this.dataToShow.map(contribution => {
          const descriptionMaxLength = contribution.commentsCount ? 150 : 200;

          if (contribution.content && contribution.content.length > descriptionMaxLength) {
            contribution.content = contribution.content.substring(0, descriptionMaxLength) + "&hellip;";
          }
          if (contribution.created) {
            contribution.created = moment(contribution.created);
            contribution.formattedCreated = contribution.created.format("DD.MM.YYYY HH:mm");
          }
          contribution.link = "//" + contribution.domainid + "." + location.hostname + "/#/contribution/" + contribution.nid;
          contribution.formattedDistricts = Object.values(contribution.proceedingDistricts).join(", ");
          contribution.formattedTopics = Object.values(contribution.proceedingTopics).join(", ");
          return contribution;
        });
      }

      return [];
    }
  },
  watch: {
    dataToShow: {
      deep: true,
      handler () {
        this.openedContribution = 0;
      }
    }
  },
  methods: {
    commentCountLabel (contribution) {
      return contribution.commentsCount
        ? this.$t("components.TopContributions.numComments") + contribution.commentsCount
        : "";
    },
    slideContent (page) {
      this.openedContribution = page;
    },
    slideTitle (page) {
      return this.$t("components.TopContributions.slideTitle") + (page + 1);
    },
    openDetails (contribution) {
      window.open(contribution.link);
    },
    changePage (direction) {
      if (direction === -1 && this.openedContribution > 0) {
        this.openedContribution--;
      }
      else if (direction === 1 && this.openedContribution < 2) {
        this.openedContribution++;
      }
    }
  }
};
</script>

<template>
  <div class="TopContributionsByValue">
    <section
      v-for="(contribution, index) in contributionList"
      :key="'contribution-' + index"
      class="contribution"
      :class="{active: openedContribution === index}"
    >
      <div
        v-if="openedContribution === index"
        class="content"
      >
        <span
          class="districts"
          :title="contribution.formattedDistricts"
        >
          <i class="icon icon-map" />
          {{ contribution.formattedDistricts }}
        </span>

        <span
          class="title"
          :title="contribution.title"
        >
          {{ contribution.title }}
        </span>

        <span
          class="topics"
          :title="contribution.formattedTopics"
        >
          {{ contribution.formattedTopics }}
        </span>

        <span
          v-if="contribution.created && !contribution.commentsCount"
          class="created"
          :title="contribution.formattedCreated"
        >
          {{ contribution.formattedCreated }}
        </span>

        <div
          class="description"
          v-html="contribution.content"
        />

        <span
          v-if="contribution.commentsCount"
          class="commentCount"
          :title="commentCountLabel(contribution)"
        >
          {{ commentCountLabel(contribution) }}
        </span>

        <div class="buttonContainer">
          <DipasButton
            :label="$t('components.TopContributions.moreButtonLabel')"
            @click="openDetails(contribution)"
            @keyup.enter="openDetails(contribution)"
          />
        </div>
      </div>
    </section>

    <div class="bottomSlideLine">
      <div
        class="slide-line slide-line-left"
        @click="changePage(-1)"
      >
        <span class="arrow-line" />
        <span class="arrow-head arrow-head-left" />
      </div>

      <span
        v-for="(contribution, index) in contributionList"
        :key="'slide-circle-' + index"
        class="slide-circle"
        :class="{'slide-circle-active': openedContribution === index}"
        :title="slideTitle(index)"
        role="button"
        tabindex="0"
        @click="slideContent(index)"
        @keyup.enter="slideContent(index)"
      />

      <div
        class="slide-line slide-line-right"
        @click="changePage(1)"
      >
        <span class="arrow-line" />
        <span class="arrow-head arrow-head-right" />
      </div>
    </div>
  </div>
</template>

<style lang="scss">
@import "../../../scss/_global.scss";

div.TopContributionsByValue {
  display: flex;
  flex-direction: column;
  overflow: hidden;
  height: 100%;

  section.contribution {
    display: flex;
    flex-direction: row;
    overflow: hidden;

    & > div.content {
      flex: 1;
      overflow: hidden;
      padding-bottom: 60px;
      position: relative;

      p {
        @extend %fontdefinition_text;
      }

      div.description {
        @extend %fontdefinition_text;
        margin-bottom: 12px;
        text-overflow: ellipsis;
      }

      span {
        display: block;
        overflow: hidden;
        @extend %fontdefinition_body;

        &.districts {
          @extend %fontdefinition_rubric;
          color: $color_diagram_03;
          white-space: nowrap;
          text-overflow: ellipsis;

          i {
            position: relative;
            top: 2px;
            color: $color_diagram_03;
            width: 15px;
          }
        }

        &.title,
        &.commentCount {
          @extend %fontdefinition_subline;
          color: $color_primary_1;
          margin-bottom: 3px;
          white-space: nowrap;
          text-overflow: ellipsis;
        }

        &.topics {
          @extend %fontdefinition_rubric;
          color: $color_diagram_02;
          margin-bottom: 2px;
          white-space: nowrap;
          text-overflow: ellipsis;
        }

        &.created {
          @extend %fontdefinition_rubric;
          margin-bottom: 12px;
          white-space: nowrap;
          text-overflow: ellipsis;
        }
      }

      div.buttonContainer {
        display: flex;
        justify-content: center;
      }

      button {
        position: absolute;
        bottom: 30px;
      }
    }

    &.active {
      height: 100%;
    }
  }

  div.bottomSlideLine {
    display: flex;
    flex-direction: row;
    justify-content: center;
    margin-bottom: 5px;

    span.slide-circle {
      border: 1px solid $color_primary_1;
      border-radius: 10px;
      width: 10px;
      height: 10px;
      background: white;
      margin-left: 5px;
      margin-top: 6px;
      cursor: pointer;

      &-active {
        background: $color_primary_1;
      }

      &:first-of-type {
        margin-left: 0;
      }
    }

    div.slide-line {
      flex: 1;
      position: relative;
      height: 25px;
      margin-right: 10px;
      margin-left: 10px;
      cursor: pointer;

      &-left {
        margin-left: 2px;
      }

      &-right {
        margin-right: 2px;
      }

      span {
        position: absolute;
        display: inline-block;

        &.arrow-line {
          width: 100%;
          border: solid $color_primary_1;
          border-top-width: 2px;
          border-right-width: 0;
          border-bottom-width: 0;
          border-left-width: 0;
          top: 10px;
        }

        &.arrow-head {
          top: 6px;
          width: 10px;
          height: 10px;
          border: solid $color_primary_1;
          border-top-width: 0;
          border-right-width: 0;
          border-bottom-width: 2px;
          border-left-width: 2px;

          &-left {
            left: 0;
            transform: rotate(45deg);
            -webkit-transform: rotate(45deg);
          }

          &-right {
            right: 0;
            transform: rotate(-135deg);
            -webkit-transform: rotate(-135deg);
          }
        }
      }
    }
  }
}
</style>
